/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.ws.mdp;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import javax.swing.JPanel;

/**
 *
 * @author Karel Horak
 */
public class GridWorldPanel extends JPanel {
    
    private MDPState grid[][];
    private int height;
    private int width;
    
    public GridWorldPanel(MDPState grid[][], int height, int width) {
        this.grid = grid;
        this.height = height;
        this.width = width;
    }
    
    @Override
    public void paint(Graphics g) {
        int dw = getWidth();
        int dh = getHeight();
        
        int cw = dw / width;
        int ch = dh / height;
        
        g.setColor(Color.white);
        g.fillRect(0, 0, dw, dh);
        
        g.setColor(Color.black);
        for(int i = 0; i < width; i++) {
            g.drawLine(i * cw, 0, i * cw, dh);
        }
        for(int j = 0; j < height; j++) {
            g.drawLine(0, j * ch, dw, j * ch);
        }
        
        g.setFont(new Font("Arial", Font.BOLD, 10));
        for(int i = 0; i < height; i++) {
            for(int j = 0; j < width; j++) {
                if(grid[i][j] != null) {
                    g.drawString(String.format("%1.5f", grid[i][j].getEvaluation()), (j*cw) + (cw/2) - 30, (i*ch) + (ch/2) - 6);
                    MDPAction a = grid[i][j].getOptimalAction();
                    
                    if(a != null) {
                        g.setColor(Color.blue);
                        if(a.getName().equals("movement (-1,0)")) {
                            g.fillRect(j*cw, i*ch + ch/2 - 3, 6, 6);
                        } else if(a.getName().equals("movement (1,0)")) {
                            g.fillRect(j*cw + cw - 6, i*ch + ch/2 - 3, 6, 6);
                        } else if(a.getName().equals("movement (0,-1)")) {
                            g.fillRect(j*cw + cw/2 - 3, i*ch, 6, 6);
                        } else if(a.getName().equals("movement (0,1)")) {
                            g.fillRect(j*cw + cw/2 - 3, i*ch + ch - 6, 6, 6);
                        }
                        g.setColor(Color.black);
                    }
                } else {
                    g.fillRect(j*cw, i*ch, cw, ch);
                }
            }
        }
    }
}
