/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.ws.mdp;

import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author Karel Horak
 */
public class MDPProblem {
    
    private List<MDPState> states;
    private double stepCost = 0.0;
    
    public MDPProblem() {
        states = new LinkedList<MDPState>();
    }
    
    public void addState(MDPState s) {
        states.add(s);
    }
    public void clearStates() {
        states.clear();
    }
    
    public void setStepCost(double cost) {
        this.stepCost = cost;
    }
    
    public int solve(double threshold) {
        if(states.isEmpty()) return 0;
        
        boolean stable = false;
        int iterations = 0;
        while(!stable) {
            iterations++;
            stable = true;
            for(MDPState s : states) {
                s.update(stepCost);
                stable &= !s.commit(threshold);
            }
        }
        
        return iterations;
    }
}
