/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.ws.mdp;

import java.awt.GridLayout;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import org.math.plot.Plot2DPanel;

/**
 *
 * @author Karel Horak
 */
public class Main extends javax.swing.JFrame {

    private static final double STEP = 0.3;
    private static final double THRESHOLD = 0.00001;
    private static final int NUM_TESTS = 400;

    /**
     * Creates new form Main
     */
    public Main() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel2 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel3 = new javax.swing.JLabel();
        tolerance = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jSeparator3 = new javax.swing.JSeparator();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        rows = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        cols = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        probStraight = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        probRight = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        probLeft = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        stepCost = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        positiveReward = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        negativeReward = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        worldDef = new javax.swing.JTextArea();
        jLabel18 = new javax.swing.JLabel();
        jButton4 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Russell's world");
        setResizable(false);

        jButton1.setText("Solve Russell's world");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                solveRW(evt);
            }
        });

        jButton2.setText("Find marginal value for the step cost");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bisectionSolver(evt);
            }
        });

        jButton3.setText("Run performance test");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                performanceTest(evt);
            }
        });

        jLabel1.setText("Solves the basic MDP task...");

        jLabel2.setText("<html>Try to find the marginal value for the step cost where the agent tries the risky way<br />before the obstacle rather than enduring the lenghty way around it.</html>");

        jLabel3.setText("Tolerance:");

        tolerance.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        tolerance.setText("0.001");

        jLabel4.setText("<html>Runs the performance test to estimate time complexity of Value iteration for solving<br />MDP problems depending on the number of states.</html>");

        jLabel5.setText("<html>Make the world look just as you want. Enter the dimensions of the world, enter the<br/>probabilities of action outcomes and define the world.</html>");

        jLabel6.setText("Rows:");

        rows.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        rows.setText("3");

        jLabel7.setText("Columns:");

        cols.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        cols.setText("4");

        jLabel8.setText("Outcome probabilities:");

        jLabel9.setText("Straight:");

        probStraight.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        probStraight.setText("0.8");

        jLabel10.setText("Right:");

        probRight.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        probRight.setText("0.1");

        jLabel11.setText("Left:");

        probLeft.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        probLeft.setText("0.1");

        jLabel12.setText("Step cost:");

        stepCost.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        stepCost.setText("0.04");

        jLabel13.setText("Rewards:");

        jLabel14.setText("Positive:");

        positiveReward.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        positiveReward.setText("1");

        jLabel15.setText("Negative:");

        negativeReward.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        negativeReward.setText("-1");

        jLabel16.setText("World definition:");

        jLabel17.setText("<html>Enter the world definition in one string. Start by entering the value for the top<br /> left cell, then type the first row and continue by the next row.");

        worldDef.setColumns(20);
        worldDef.setRows(5);
        worldDef.setText("---r-w-p----");
        jScrollPane1.setViewportView(worldDef);

        jLabel18.setText("<html>- / empty cell<br/>w / wall<br/>r / reward<br/>p / penalty</html>");

        jButton4.setText("Solve your world");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                solveCustom(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButton3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jSeparator1)
                            .addComponent(jSeparator2)
                            .addComponent(jSeparator3)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel1)
                                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(7, 7, 7))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel8)
                                .addGap(0, 0, Short.MAX_VALUE))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(39, 39, 39)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 331, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(layout.createSequentialGroup()
                                        .addGap(18, 18, 18)
                                        .addComponent(jButton4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(tolerance, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(40, 40, 40)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel9)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(probStraight, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jLabel10)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(probRight, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jLabel11)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(probLeft, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel12)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(stepCost, javax.swing.GroupLayout.PREFERRED_SIZE, 66, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jLabel13))
                            .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(38, 38, 38)
                                .addComponent(jLabel6)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(rows, javax.swing.GroupLayout.PREFERRED_SIZE, 145, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel7)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(cols, javax.swing.GroupLayout.PREFERRED_SIZE, 153, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(41, 41, 41)
                                .addComponent(jLabel14)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(positiveReward, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel15)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(negativeReward, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jLabel16)))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(tolerance, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(rows, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(cols, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(probStraight, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10)
                    .addComponent(probRight, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel11)
                    .addComponent(probLeft, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel12)
                    .addComponent(stepCost, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel13)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(positiveReward, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel15)
                    .addComponent(negativeReward, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel16)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton4))
                    .addComponent(jScrollPane1))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void solveRW(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_solveRW
        final RussellGridWorld p = new RussellGridWorld(3, 4);
        p.setProbabilities(0.8, 0.1, 0.1);
        p.setRewards(-1.0, 1.0);
        p.setStepCost(1.0 / 25);
        p.load("---r-w-p----");

        Measure m = new Measure(new MeasureTask() {

            @Override
            public Object run() {
                return p.solve(THRESHOLD);
            }
        });
        m.measure();

        JOptionPane.showMessageDialog(rootPane,
                String.format("<html>Value iteration needed %d iterations to converge in %d &micro;s</html>",
                (Integer) m.getReturnValue(), m.getTime() / 1000));
        GridWorldDisplay gwd = new GridWorldDisplay(this, p.getGrid(), p.getHeight(), p.getWidth());
        gwd.setModal(true);
        gwd.setVisible(true);
    }//GEN-LAST:event_solveRW

    private void bisectionSolver(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bisectionSolver
        double lower = Double.NEGATIVE_INFINITY;
        double upper = Double.POSITIVE_INFINITY;
        double toleranceValue;
        try {
            toleranceValue = 2 * Double.parseDouble(tolerance.getText());
        } catch(NumberFormatException nfe) {
            JOptionPane.showMessageDialog(rootPane, "The number you have entered is not a valid double!", "Malformed input", JOptionPane.ERROR_MESSAGE);
            return;
        }

        if (!takesShorter(0.0)) {
            lower = 0.0;
            for (upper = lower + STEP; !takesShorter(upper););
        } else {
            upper = 0.0;
            for (lower = upper - STEP; takesShorter(lower););
        }

        while (upper - lower > toleranceValue) {
            double newStepCost = (upper + lower) / 2;
            if (!takesShorter(newStepCost)) {
                lower = newStepCost;
            } else {
                upper = newStepCost;
            }
        }

        JOptionPane.showMessageDialog(rootPane, String.format("Critical value for step cost is %1.7f", (upper + lower) / 2));
    }//GEN-LAST:event_bisectionSolver

    private void performanceTest(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_performanceTest
        double time[] = new double[NUM_TESTS];
        double iterations[] = new double[NUM_TESTS];
        double timepi[] = new double[NUM_TESTS];
        double states[] = new double[NUM_TESTS];

        StringBuilder sb = new StringBuilder("---r-w-p----");
        String s = "-w--";
        int height = 3;
        double cstates = 11;

        for (int i = 0; i < NUM_TESTS; i++) {
            final RussellGridWorld p = new RussellGridWorld(height, 4);
            p.setProbabilities(0.8, 0.1, 0.1);
            p.setRewards(-1.0, 1.0);
            p.setStepCost(1.0 / 25);
            p.load(sb.toString());

            Measure m = new Measure(new MeasureTask() {

                @Override
                public Object run() {
                    return p.solve(THRESHOLD);
                }
            });
            m.measure();

            iterations[i] = (double) ((Integer) m.getReturnValue());
            time[i] = (double) m.getTime();
            timepi[i] = time[i] / iterations[i];
            states[i] = cstates;

            height++;
            cstates += 3;
            sb.insert(4, s);
        }

        Plot2DPanel plot1 = new Plot2DPanel();
        plot1.addLegend("SOUTH");
        plot1.addLinePlot("Iterations per number of states", states, iterations);

        Plot2DPanel plot2 = new Plot2DPanel();
        plot2.addLegend("SOUTH");
        plot2.addLinePlot("Time (ns) per iteration (based on number of states)", states, timepi);

        Plot2DPanel plot3 = new Plot2DPanel();
        plot3.addLegend("SOUTH");
        plot3.addLinePlot("Time (ns) / number of states", states, time);

        JDialog dialog = new JDialog(this, "Plot");
        JPanel top = new JPanel();
        top.setLayout(new GridLayout(1, 2));
        top.add(plot1);
        top.add(plot2);

        dialog.setLayout(new GridLayout(2, 1));
        dialog.add(top);
        dialog.add(plot3);
        dialog.setModal(true);
        dialog.setSize(800, 600);
        dialog.setVisible(true);
    }//GEN-LAST:event_performanceTest

    private void solveCustom(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_solveCustom
        int width;
        int height;
        double pStraight, pLeft, pRight;
        double sCost;
        double rPos, rNeg;
        String wDef;
        
        try {
            width = Integer.parseInt(cols.getText());
            height = Integer.parseInt(rows.getText());
            pStraight = Double.parseDouble(probStraight.getText());
            pLeft = Double.parseDouble(probLeft.getText());
            pRight = Double.parseDouble(probRight.getText());
            sCost = Double.parseDouble(stepCost.getText());
            rPos = Double.parseDouble(positiveReward.getText());
            rNeg = Double.parseDouble(negativeReward.getText());
            
            if(
                    pStraight < 0.0 || pStraight > 1.0 ||
                    pLeft < 0.0 || pLeft > 1.0 ||
                    pRight < 0.0 || pRight > 1.0) {
                throw new IllegalArgumentException();
            }
        } catch(Exception e) {
            JOptionPane.showMessageDialog(this, "You have entered invalid input", "Check your input", JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        wDef = worldDef.getText();
        if(wDef.length() != width * height) {
            JOptionPane.showMessageDialog(this, "World definition must have exactly " + (width * height) + "characters!", "Check your input", JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        final RussellGridWorld p = new RussellGridWorld(height, width);
        p.setProbabilities(pStraight, pRight, pLeft);
        p.setRewards(rNeg, rPos);
        p.setStepCost(sCost);
        
        try {
            p.load(wDef);
        } catch(IllegalArgumentException iae) {
            JOptionPane.showMessageDialog(this, "World definition contains invalid character!", "Check your input", JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        Measure m = new Measure(new MeasureTask() {

            @Override
            public Object run() {
                return p.solve(THRESHOLD);
            }
        });
        m.measure();

        JOptionPane.showMessageDialog(rootPane,
                String.format("<html>Value iteration needed %d iterations to converge in %d &micro;s</html>",
                (Integer) m.getReturnValue(), m.getTime() / 1000));
        GridWorldDisplay gwd = new GridWorldDisplay(this, p.getGrid(), p.getHeight(), p.getWidth());
        gwd.setModal(true);
        gwd.setVisible(true);
    }//GEN-LAST:event_solveCustom

    private boolean takesShorter(double stepCost) {
        RussellGridWorld p = new RussellGridWorld(3, 4);
        p.setProbabilities(0.8, 0.1, 0.1);
        p.setRewards(-1.0, 1.0);
        p.setStepCost(stepCost);
        p.load("---r-w-p----");

        p.solve(THRESHOLD);

        return !p.getGrid()[2][2].getOptimalAction().getName().equals("movement (-1,0)");
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new Main().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField cols;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JTextField negativeReward;
    private javax.swing.JTextField positiveReward;
    private javax.swing.JTextField probLeft;
    private javax.swing.JTextField probRight;
    private javax.swing.JTextField probStraight;
    private javax.swing.JTextField rows;
    private javax.swing.JTextField stepCost;
    private javax.swing.JTextField tolerance;
    private javax.swing.JTextArea worldDef;
    // End of variables declaration//GEN-END:variables
}
